// ignore_for_file:  constant_identifier_names

import 'dart:math' as math;

class GeneralFormulas {
  /// Volume:1/6 x π
  static const double VolumeCofficient = math.pi / 6.0;

  /// 带比率系数算体积
  ///
  /// [coefficient] 比率系数
  static double volumeWithCoefficient(
    double d1,
    double d2,
    double d3,
    double coefficient,
  ) {
    double volume = 0;
    if (!doubleAlmostEquals(d1, 0) &&
        !doubleAlmostEquals(d2, 0) &&
        !doubleAlmostEquals(d3, 0)) {
      volume = d1 * d2 * d3 * coefficient;
    }
    return volume;
  }

  static bool doubleAlmostEquals(double num1, double num2,
      [double precision = 0.000001]) {
    if (num1.isNaN && num2.isNaN) return true;
    return (num1 - num2).abs() <= precision;
  }
}
